local f = CreateFrame("Frame")
local healers = {}
local dispeller = ""
local bestTime = 0
local enabled = false
local slaves = {}
local player = UnitName("player")
local ticks = 0
local debuffed = false
local master = "Ant"
local queue = {}
local nearby = {}
f:RegisterEvent("ENCOUNTER_START")
f:RegisterEvent("CHAT_MSG_ADDON")
f:RegisterEvent("UNIT_AURA")
f:RegisterEvent("RAID_TARGET_UPDATE")
f:RegisterEvent("PLAYER_LOGIN")
RegisterAddonMessagePrefix("EnRT_ITSHealer")
RegisterAddonMessagePrefix("EnRT_ITSMarks") --Nearby
f:SetScript("OnUpdate",function(self, elapsed)
	if debuffed and EnRT_ImonarSoulhunterEnabled then
		ticks = ticks + elapsed
		if ticks > 0.05 then
			local safe = true
			for i = 1, GetNumGroupMembers() do
				local raider = "raid"..i
				local name = GetUnitName(raider, true)
				if UnitIsVisible(raider) and GetUnitName(raider, true) ~= player then
					if CheckInteractDistance(raider, 3) and UnitIsConnected(master) and not EnRT_Contains(nearby, name) then --Duel range is 9.9y
						safe = false
						nearby[#nearby+1] = name
						SendAddonMessage("EnRT_ITSMarks", "NEARBY|"..name, "WHISPER", master)
					elseif UnitIsConnected(master) and EnRT_Contains(nearby, name) then
						nearby[EnRT_Contains(nearby, name)] = nil
						SendAddonMessage("EnRT_ITSMarks", "AWAY|"..name, "WHISPER", master)
					end
					if UnitIsConnected(master) and safe then
						safe = true
					end
				end
			end
			if safe and UnitIsConnected(master) and UnitDebuff(player, GetSpellInfo(233983)) then--247552
				SendAddonMessage("EnRT_ITSHealer", "SHOW", "RAID")
			elseif not safe and UnitIsConnected(master) and UnitDebuff(player, GetSpellInfo(233983))then
				SendAddonMessage("EnRT_ITSHealer", "HIDE", "RAID")
			end
			ticks = 0
		end
	end
end)
f:SetScript("OnEvent", function(self, event, ...)
	if event == "ENCOUNTER_START" and EnRT_ImonarSoulhunterEnabled then
		queue = {}
		local eID = ...
		if eID == 2048 then--2082
			enabled = true
			master = EnRT_GetRaidLeader()
		end
	elseif event == "PLAYER_LOGIN" then
		if EnRT_ImonarSoulhunterEnabled == nil then EnRT_ImonarSoulhunterEnabled = true end
	elseif event == "RAID_TARGET_UPDATE" and EnRT_ImonarSoulhunterEnabled then
		for k, v in pairs(queue) do
			if GetRaidTargetIndex(k) and v == "mark" then
				queue[k] = nil
			elseif not GetRaidTargetIndex(k) and v == "unmark" then
				queue[k] = nil
			end
		end
	elseif event == "CHAT_MSG_ADDON" and EnRT_ImonarSoulhunterEnabled then
		local prefix, msg, channel, sender = ...
		if prefix == "EnRT_ITSHealer" and player == master then
			sender = Ambiguate(sender, "short")
			if UnitGroupRolesAssigned("player") == "HEALER" then
				if msg == "SHOW" then
					RAT_PopupShow("DISPELL " .. sender, 5)
				elseif msg == "HIDE" then
					RAT_PopupHide()
				end
			end
		elseif prefix == "EnRT_ITSMarks" and player == master then
			local loc, name = msg:match("(.*)|(.*)") -- capture everything until | and then capture everything after |
			if loc == "NEARBY" and not EnRT_Contains(nearby, name) then
				nearby[#nearby+1] = name
			elseif loc == "AWAY" and EnRT_Contains(nearby, name) then
				nearby[EnRT_Contains(nearby, name)] = nil
			end
			local isNearby = EnRT_Contains(nearby, name)
			if isNearby then
				if GetRaidTargetIndex(name) == nil and not EnRT_ContainsKey(queue, name) then
					queue[name] = "mark"
					SetRaidTarget(name, (EnRT_Contains(nearby, name)+1))
				end
			else
				if GetRaidTargetIndex(name) and not EnRT_ContainsKey(queue, name) then
					queue[name] = "unmark"
					SetRaidTarget(name, 0)
				end
			end
		end
	elseif event == "UNIT_AURA" and EnRT_ImonarSoulhunterEnabled then
		if player == master then
			local unit = ...
			local unitName = GetUnitName(unit, true)
			if UnitDebuff(unit, GetSpellInfo(233983)) then --Sleep canister
				if not EnRT_Contains(slaves, unitName) then
					slaves[#slaves+1] = unitName
					SetRaidTarget(unitName, #slaves)
				end
			else
				if EnRT_Contains(slaves, unitName) then
					slaves[EnRT_Contains(slaves, unitName)] = nil
					SetRaidTarget(unitName, 0)
					SendAddonMessage("EnRT_ITSHealer", "HIDE", "RAID")
				end
			end
		end
		if UnitDebuff(player, GetSpellInfo(233983)) then
			debuffed = true
		else
			debuffed = false
		end
	end
end)
--[[
	Checking if a table PGF_Contains a given value and if it does, what index is the value located at
	param(arr) table
	param(value) T - value to check exists
	return boolean or integer / returns false if the table does not contain the value otherwise it returns the index of where the value is locatedd
]]
function EnRT_Contains(arr, value)
	if value == nil then
		return false
	end
	if arr == nil then
		return false
	end
	for k, v in pairs(arr) do
		if v == value then
			return k
		end
	end
	return false
end
--[[
	Checking if a table contains a given value and if it does, what index is the value located at
	param(arr) table
	param(value) T - value to check exists
	return boolean or integer / returns false if<< the table does not contain the value otherwise it returns the index of where the value is locatedd
]]
function EnRT_ContainsKey(arr, value)
	if value == nil then
		return false
	end
	if arr == nil then
		return false
	end
	for k, v in pairs(arr) do
		if k == value then
			return true
		end
	end
	return false
end
function EnRT_GetRaidLeader()
	for i = 1, GetNumGroupMembers() do
		local raider = "raid"..i
		if select(2, GetRaidRosterInfo(i)) == 2 then
			return GetUnitName(raider, true)
		end
	end
	return ""
end
